package com.jenny.advancedarrows;

import com.jenny.advancedarrows.config.ConfigClient;
import com.jenny.advancedarrows.config.ConfigCommon;
import com.jenny.advancedarrows.entities.entities;
import com.jenny.advancedarrows.items.items;
import com.jenny.advancedarrows.particles.particles;
import com.mojang.logging.LogUtils;
import net.minecraftforge.api.distmarker.Dist;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.event.server.ServerStartingEvent;
import net.minecraftforge.eventbus.api.IEventBus;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.fml.ModLoadingContext;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.fml.config.ModConfig;
import net.minecraftforge.fml.event.lifecycle.FMLClientSetupEvent;
import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent;
import net.minecraftforge.fml.javafmlmod.FMLJavaModLoadingContext;
import org.slf4j.Logger;

// The value here should match an entry in the META-INF/mods.toml file
@Mod(advancedArrows.MODID)
public class advancedArrows {

    public static final String MODID = "advancedarrows";
    private static final Logger LOGGER = LogUtils.getLogger();

    public advancedArrows() {
        IEventBus modEventBus = FMLJavaModLoadingContext.get().getModEventBus();

        modEventBus.addListener(this::commonSetup);

        entities.register(modEventBus);
        items.register(modEventBus);
        creativeTab.register(modEventBus);
        particles.register(modEventBus);

        MinecraftForge.EVENT_BUS.register(this);
        ModLoadingContext.get().registerConfig(ModConfig.Type.CLIENT, ConfigClient.SPEC, "AdvancedArrows-client.toml");
        ModLoadingContext.get().registerConfig(ModConfig.Type.COMMON, ConfigCommon.SPEC, "AdvancedArrows-common.toml");
    }

    private void commonSetup(final FMLCommonSetupEvent event) {
        items.registerDispenser();
    }

    @SubscribeEvent
    public void onServerStarting(ServerStartingEvent event) {
    }

    @Mod.EventBusSubscriber(modid = MODID, bus = Mod.EventBusSubscriber.Bus.MOD, value = Dist.CLIENT)
    public static class ClientModEvents {

        @SubscribeEvent
        public static void onClientSetup(FMLClientSetupEvent event) {
            entities.registerRenderers();
        }
    }
}
