package com.jenny.advancedarrows.entities;

import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.projectile.AbstractArrow;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.Level;
import net.minecraft.world.phys.Vec3;
import org.jetbrains.annotations.NotNull;

public class baseArrow extends AbstractArrow {
    private final Item itemPickup;
    private int tick = 0;

    public baseArrow(EntityType<? extends baseArrow> pEntityType, Level pLevel, Item item) {
        super(pEntityType, pLevel, item.getDefaultInstance());
        this.itemPickup = item;
    }

    public baseArrow(Level pLevel, LivingEntity pShooter, EntityType<? extends baseArrow> pEntityType, Item item) {
        super(pEntityType, pShooter, pLevel, item.getDefaultInstance());
        this.itemPickup = item;
    }

    public void tick() {
        super.tick();
        if (this.level().isClientSide) {
            if (!this.inGround) {
                spawnParticles();
            }
            this.tick++;
        } else if (this.inGround && this.inGroundTime != 0 && this.inGroundTime >= 600) {
            this.level().broadcastEntityEvent(this, (byte)0);
        }
    }

    @NotNull
    protected ItemStack getPickupItem() {
        return itemPickup.getDefaultInstance();
    }

    @Override
    protected @NotNull ItemStack getDefaultPickupItem() {
        if (itemPickup == null) {
            return ItemStack.EMPTY;
        } else {
            return new ItemStack(itemPickup);
        }
    }

    public void handleEntityEvent(byte pId) {
        if (pId != 0) {
            super.handleEntityEvent(pId);
        }

    }

    public Vec3 createParticlePos(float range) {
        return new Vec3(
                (double) level().getRandom().nextIntBetweenInclusive(-100, 100) / 100,
                (double) level().getRandom().nextIntBetweenInclusive(-100, 100) / 100,
                (double) level().getRandom().nextIntBetweenInclusive(-100, 100) / 100
        ).normalize().scale(range).add(position());
    }

    public Vec3 createParticlePos(Entity entity, float range) {
        return new Vec3(
                (double) level().getRandom().nextIntBetweenInclusive(-100, 100) / 100,
                (double) level().getRandom().nextIntBetweenInclusive(-100, 100) / 100,
                (double) level().getRandom().nextIntBetweenInclusive(-100, 100) / 100
        ).normalize().scale(range).add(entity.position());
    }

    public void spawnParticles() {
    }

    public int getTick() {
        return this.tick;
    }
}
