package com.jenny.advancedarrows.entities;

import com.jenny.advancedarrows.config.ConfigClient;
import net.minecraft.core.particles.ParticleTypes;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.Items;
import net.minecraft.world.level.Level;
import net.minecraft.world.phys.HitResult;
import net.minecraft.world.phys.Vec3;
import org.jetbrains.annotations.NotNull;

public class enderArrow extends baseArrow {
    static final Item item = Items.AIR;

    public enderArrow(EntityType<enderArrow> pEntityType, Level pLevel) {
        super(pEntityType, pLevel, item);
    }

    public enderArrow(Level pLevel, LivingEntity pShooter) {
        super(pLevel, pShooter, entities.ARROW_ENDER.get(), item);
    }

    @Override
    protected void onHit(@NotNull HitResult pResult) {
        super.onHit(pResult);
        if (getOwner() != null) {
            Vec3 pos = pResult.getLocation();
            level().getPlayerByUUID(getOwner().getUUID()).teleportTo(pos.x, pos.y, pos.z);
        }
        discard();
    }

    @Override
    public void spawnParticles() {
        for (int i = 1; i <= ConfigClient.calcPCount(5); i++) {
            Vec3 pos = createParticlePos(1f);
            level().addParticle(ParticleTypes.GLOW, pos.x, pos.y, pos.z, 0, 0, 0);
        }
    }
}
