package com.jenny.advancedarrows.entities;

import com.jenny.advancedarrows.config.ConfigClient;
import com.jenny.advancedarrows.items.items;
import net.minecraft.core.particles.ParticleTypes;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.item.Item;
import net.minecraft.world.level.Level;
import net.minecraft.world.phys.EntityHitResult;
import net.minecraft.world.phys.Vec3;
import org.jetbrains.annotations.NotNull;

public class kineticArrow extends baseArrow{
    static final Item item = items.ARROW_KINETIC.get();

    public kineticArrow(EntityType<kineticArrow> pEntityType, Level pLevel) {
        super(pEntityType, pLevel, item);
    }

    public kineticArrow(Level pLevel, LivingEntity pShooter) {
        super(pLevel, pShooter, entities.ARROW_KINETIC.get(), item);
    }

    @Override
    protected void onHitEntity(@NotNull EntityHitResult pTarget) {
        super.onHitEntity(pTarget);
        Entity target = pTarget.getEntity();
        target.addDeltaMovement(getDeltaMovement().multiply(1.5, 0.2, 1.5));
    }

    @Override
    public void spawnParticles() {
        for (int i = 1; i <= ConfigClient.calcPCount(5); i++) {
            Vec3 pos = createParticlePos(1f);
            level().addParticle(ParticleTypes.ELECTRIC_SPARK, pos.x, pos.y, pos.z, 0, 0, 0);
        }
    }
}
