package com.jenny.advancedarrows.entities;

import com.jenny.advancedarrows.items.items;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.item.Item;
import net.minecraft.world.level.Level;
import net.minecraft.world.phys.Vec3;

public class ricochetArrow extends baseArrow{
    static final Item item = items.ARROW_RICOCHET.get();

    public ricochetArrow(EntityType<ricochetArrow> pEntityType, Level pLevel) {
        super(pEntityType, pLevel, item);
    }

    public ricochetArrow(Level pLevel, LivingEntity pShooter) {
        super(pLevel, pShooter, entities.ARROW_RICOCHET.get(), item);
    }

    @Override
    public void tick() {
        Vec3 pos = position();
        Vec3 delta = getDeltaMovement();
        super.tick();
        if (this.inGround && !level().isClientSide) {
            if (delta.length() > 0.5) {
                //setOnGround(false);
                setPos(pos);
                setDeltaMovement(delta.scale(-7).multiply(
                        (double) level().random.nextIntBetweenInclusive(90, 100) / 100,
                        (double) level().random.nextIntBetweenInclusive(90, 100) / 100,
                        (double) level().random.nextIntBetweenInclusive(90, 100) / 100));
            }
        }
    }
}
