package com.jenny.advancedarrows.entities;

import com.jenny.advancedarrows.config.ConfigClient;
import com.jenny.advancedarrows.items.items;
import net.minecraft.core.particles.ParticleTypes;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.item.Item;
import net.minecraft.world.level.Level;
import net.minecraft.world.phys.EntityHitResult;
import net.minecraft.world.phys.Vec3;
import org.jetbrains.annotations.NotNull;

public class switchArrow extends baseArrow{
    static final Item item = items.ARROW_SWITCH.get();

    public switchArrow(EntityType<switchArrow> pEntityType, Level pLevel) {
        super(pEntityType, pLevel, item);
    }

    public switchArrow(Level pLevel, LivingEntity pShooter) {
        super(pLevel, pShooter, entities.ARROW_SWITCH.get(), item);
    }

    @Override
    protected void onHitEntity(@NotNull EntityHitResult pTarget) {
        super.onHitEntity(pTarget);
        Entity owner = this.getOwner();
        if (owner != null) {
            Vec3 targetPos = owner.position();
            Vec3 ownerPos = pTarget.getEntity().position();
            pTarget.getEntity().setPos(targetPos);
            //owner.setPos(ownerPos) doesn't work somehow, idk why
            level().getPlayerByUUID(owner.getUUID()).teleportTo(ownerPos.x, ownerPos.y, ownerPos.z);
        }
        discard();
    }

    @Override
    public void spawnParticles() {
        for (int i = 1; i <= ConfigClient.calcPCount(5); i++) {
            Vec3 pos = createParticlePos(1f);
            level().addParticle(ParticleTypes.GLOW, pos.x, pos.y, pos.z, 0, 0, 0);
        }
    }
}
